#include <GDIPlus.au3>
#include <Kollision.au3>
#include <Misc.au3>
#include <Array.au3>
_GDIPlus_Startup()

Global $Change = 1, $Height, $Width, $Felder
Global $Timer = TimerInit(), $FPSTimer = TimerInit(), $FPS, $nFPS, $Image = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Baum.png")
Global $iPflanzen, $iGras, $iStrasseOben, $iStrasseRechts, $iBaum, $iStrasseRundlauf, $iMauer
$iPflanzen = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Pflanzen.png")
$iGras = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Gras.png")
$iStrasseOben = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\StrasseOben.png")
$iStrasseRechts = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\StrasseRechts.png")
$iBaum = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Baum.png")
$iStrasseRundlauf = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\StrasseRundlauf.png")
$iMauer = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Mauer.png")

Local $LoadFile = FileOpenDialog("Open Level", @ScriptDir, "LVL (*.lvl)")
If @error Then Exit
Local $Read = StringSplit(FileRead($LoadFile), "|")
Local $rRead = StringSplit($Read[1], "#")
$Width = $rRead[1]
$Height = $rRead[2]
Global $Felder[($Height / 50) * ($Height / 50) + 1][3]
For $i = 2 To UBound($Read) - 2
	Local $nRead = StringSplit($Read[$i], "#")
	$Felder[$nRead[1]][0] = $nRead[2]
	$Felder[$nRead[1]][1] = $nRead[3]
	$Felder[$nRead[1]][2] = $nRead[4]
Next
$GUI = GUICreate("TEST", 500, 500, -1, -1)
$hGraphic = _GDIPlus_GraphicsCreateFromHWND($GUI)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics(500, 500, $hGraphic)
$hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
GUISetState(@SW_SHOW)

While 1
	If _IsPressed("57") And TimerDiff($Timer) >= 100 Then ;W
		_ReOrder($Felder, 0)
		$Change = 1
		$Timer = TimerInit()
	EndIf
	If _IsPressed("41") And TimerDiff($Timer) >= 100 Then ;A
		_ReOrder($Felder, 3)
		$Change = 1
		$Timer = TimerInit()
	EndIf
	If _IsPressed("53") And TimerDiff($Timer) >= 100 Then ;S
		_ReOrder($Felder, 1)
		$Change = 1
		$Timer = TimerInit()
	EndIf
	If _IsPressed("44") And TimerDiff($Timer) >= 100 Then ;D
		_ReOrder($Felder, 2)
		$Change = 1
		$Timer = TimerInit()
	EndIf

	If $Change = 1 Then
		_GDIPlus_GraphicsClear($hBackbuffer, 0xFF005508)
		_ReDraw()
		_GDIPlus_GraphicsDrawString($hBackbuffer, $FPS, 0, 0)
		$Change = 0
	EndIf

	$nFPS += 1
	If TimerDiff($FPSTimer) >= 1000 Then
		$FPS = $nFPS
		$nFPS = 0
		$FPSTimer = TimerInit()
	EndIf
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, 500, 500)
	If GUIGetMsg() = -3 Then Exit
	Sleep(10)
WEnd

Func _ReDraw()
	_DrawTools()
	_GDIPlus_GraphicsFillRect($hBackbuffer, 250, 250, 50, 50)
EndFunc   ;==>_ReDraw
Func _Random($Min, $Max, $Step)
	For $i = $Min To $Max Step $Step
		If Random(0, 100, 1) = 5 Then Return $i
	Next
EndFunc   ;==>_Random

Func _DrawTools()
	For $i = 0 To UBound($Felder) - 1
		Switch $Felder[$i][2]
			Case 1
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iPflanzen, $Felder[$i][0], $Felder[$i][1])
			Case 2
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iGras, $Felder[$i][0], $Felder[$i][1])
			Case 3
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseOben, $Felder[$i][0], $Felder[$i][1])
			Case 4
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseRechts, $Felder[$i][0], $Felder[$i][1])
			Case 5
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iBaum, $Felder[$i][0], $Felder[$i][1])
			Case 6
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseRundlauf, $Felder[$i][0], $Felder[$i][1])
			Case 7
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iMauer, $Felder[$i][0], $Felder[$i][1])
		EndSwitch
	Next
EndFunc   ;==>_DrawTools