#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GDIPlus.au3>
#include <Misc.au3>
#include <Array.au3>

_GDIPlus_Startup()
Global $Width = 500, $Height = 500
Global $Pflanzen, $Gras, $StrasseOben, $StrasseRechts, $Baum, $iStrasseRundlauf, $iMauer, $Tool, $gPlatzieren
Global $hGraphic, $hBitmap, $hBackbuffer, $Felder[($Height / 50) * ($Height / 50) + 1][3], $PressTimer = TimerInit()
Global $iPflanzen, $iGras, $iStrasseOben, $iStrasseRechts, $iBaum, $iStrasseRundlauf, $iMauer
$iPflanzen = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Pflanzen.png")
$iGras = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Gras.png")
$iStrasseOben = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\StrasseOben.png")
$iStrasseRechts = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\StrasseRechts.png")
$iBaum = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Baum.png")
$iStrasseRundlauf = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\StrasseRundlauf.png")
$iMauer = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Bilder\Mauer.png")

#Region ### START Koda GUI section ### Form=
$SteuerGUI = GUICreate("Tools", 301, 212, 0, 0)
$Neu = GUICtrlCreateButton("Neu", 10, 8, 75, 25, $WS_GROUP)
$Speichern = GUICtrlCreateButton("Speichern", 10, 150, 75, 25, $WS_GROUP)
$Laden = GUICtrlCreateButton("Laden", 10, 180, 75, 25, $WS_GROUP)
$Pflanzen = GUICtrlCreatePic(@ScriptDir & "\Bilder\Pflanzen.jpg", 105, 10, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$Gras = GUICtrlCreatePic(@ScriptDir & "\Bilder\Gras.jpg", 160, 10, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$StrasseOben = GUICtrlCreatePic(@ScriptDir & "\Bilder\StrasseOben.jpg", 215, 10, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$StrasseRechts = GUICtrlCreatePic(@ScriptDir & "\Bilder\StrasseRechts.jpg", 105, 65, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$Baum = GUICtrlCreatePic(@ScriptDir & "\Bilder\Baum.jpg", 160, 65, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$StrasseRundlauf = GUICtrlCreatePic(@ScriptDir & "\Bilder\StrasseRundlauf.jpg", 215, 65, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$Mauer = GUICtrlCreatePic(@ScriptDir & "\Bilder\Mauer.jpg", 105, 120, 50, 50, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
$Label1 = GUICtrlCreateLabel("Feldgre", 16, 40, 51, 17)
$Size = GUICtrlCreateInput("10", 16, 64, 65, 21)


GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

$ZeichnenGUI = GUICreate("Feld", $Width + 6, $Height + 32, 306, 0, "", "", $SteuerGUI)

$hGraphic = _GDIPlus_GraphicsCreateFromHWND($ZeichnenGUI)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($Width, $Height, $hGraphic)
$hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

GUISetState(@SW_SHOW, $ZeichnenGUI)
GUISetState(@SW_SHOW, $SteuerGUI)
#EndRegion ### END Koda GUI section ###

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $Neu
			If GUICtrlRead($Size) >= 10 And GUICtrlRead($Size) <= 20 Then
				$Width = GUICtrlRead($Size) * 50
				$Height = GUICtrlRead($Size) * 50
				Global $Felder[($Height / 50) * ($Height / 50) + 1][3]
				For $i = 1 To UBound($Felder) - 1
					For $i2 = 0 To 2
						$Felder[$i][$i2] = ""
					Next
				Next
				GUISetState(@SW_HIDE, $ZeichnenGUI)
				$ZeichnenGUI = GUICreate("Feld", $Width + 6, $Height + 32, 306, 0, "", "", $SteuerGUI)
				GUISetState(@SW_SHOW, $ZeichnenGUI)
				$hGraphic = _GDIPlus_GraphicsCreateFromHWND($ZeichnenGUI)
				$hBitmap = _GDIPlus_BitmapCreateFromGraphics($Width, $Height, $hGraphic)
				$hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
			EndIf
		Case $Pflanzen
			$Tool = 1
		Case $Gras
			$Tool = 2
		Case $StrasseOben
			$Tool = 3
		Case $StrasseRechts
			$Tool = 4
		Case $Baum
			$Tool = 5
		Case $StrasseRundlauf
			$Tool = 6
		Case $Mauer
			$Tool = 7
		Case $Speichern
			Local $SaveFile = FileSaveDialog("Save Level", @ScriptDir, "LVL (*.lvl)")
			If @error Then
			Else
				FileDelete($SaveFile & ".lvl")
				FileWrite($SaveFile & ".lvl", $Width & "#" & $Height & "|")
				For $i = 1 To UBound($Felder) - 1
					FileWrite($SaveFile & ".lvl", $i & "#" & $Felder[$i][0] & "#" & $Felder[$i][1] & "#" & $Felder[$i][2] & "|")
				Next
			EndIf
		Case $Laden
			Local $LoadFile = FileOpenDialog("Open Level", @ScriptDir, "LVL (*.lvl)")
			If @error Then
			Else
				Local $Read = StringSplit(FileRead($LoadFile), "|")
				Local $rRead = StringSplit($Read[1], "#")
				$Width = $rRead[1]
				$Height = $rRead[2]
				Global $Felder[($Height / 50) * ($Height / 50) + 1][3]
				For $i = 2 To UBound($Read) - 2
					Local $nRead = StringSplit($Read[$i], "#")
					$Felder[$nRead[1]][0] = $nRead[2]
					$Felder[$nRead[1]][1] = $nRead[3]
					$Felder[$nRead[1]][2] = $nRead[4]
				Next
				GUISetState(@SW_HIDE, $ZeichnenGUI)
				$ZeichnenGUI = GUICreate("Feld", $Width + 6, $Height + 32, 306, 0, "", "", $SteuerGUI)
				GUISetState(@SW_SHOW, $ZeichnenGUI)
				$hGraphic = _GDIPlus_GraphicsCreateFromHWND($ZeichnenGUI)
				$hBitmap = _GDIPlus_BitmapCreateFromGraphics($Width, $Height, $hGraphic)
				$hBackbuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
			EndIf
	EndSwitch
	_ReDraw()
WEnd

Func _ReDraw()
	Local $hCursor = GUIGetCursorInfo($ZeichnenGUI)
	If ($hCursor[0] <= $Width And $hCursor[0] >= 0) and ($hCursor[1] <= $Height And $hCursor[1] >= 0) Then
		_GDIPlus_GraphicsClear($hBackbuffer, 0xFF005508)
		Local $Merke[2]
		Local $NewCoord[2]
		For $i = 0 To $Height Step 50
			If $i >= $hCursor[0] And $i <= ($hCursor[0] + 50) Then
				$NewCoord[0] = $i - 50
				$Merke[0] = $i / 50
			EndIf
			If $i >= $hCursor[1] And $i <= ($hCursor[1] + 50) Then
				$NewCoord[1] = $i - 50
				$Merke[1] = $i / 50
			EndIf
		Next
		If _IsPressed("01") And TimerDiff($PressTimer) >= 50 And WinActive("Feld") Then
			$PressTimer = TimerInit()
			For $i = 0 To ($Height / 50) - 1
				If $i + 1 = $Merke[1] Then
					$Felder[$Merke[0] + $i * ($Height / 50)][0] = $NewCoord[0]
					$Felder[$Merke[0] + $i * ($Height / 50)][1] = $NewCoord[1]
					Switch $Tool
						Case 1
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 1
						Case 2
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 2
						Case 3
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 3
						Case 4
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 4
						Case 5
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 5
						Case 6
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 6
						Case 7
							$Felder[$Merke[0] + $i * ($Height / 50)][2] = 7
					EndSwitch
				EndIf
			Next
		EndIf
		_DrawTools()
		If $Tool = 1 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iPflanzen, $NewCoord[0], $NewCoord[1])
		ElseIf $Tool = 2 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iGras, $NewCoord[0], $NewCoord[1])
		ElseIf $Tool = 3 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseOben, $NewCoord[0], $NewCoord[1])
		ElseIf $Tool = 4 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseRechts, $NewCoord[0], $NewCoord[1])
		ElseIf $Tool = 5 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iBaum, $NewCoord[0], $NewCoord[1])
		ElseIf $Tool = 6 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseRundlauf, $NewCoord[0], $NewCoord[1])
		ElseIf $Tool = 7 Then
			_GDIPlus_GraphicsDrawImage($hBackbuffer, $iMauer, $NewCoord[0], $NewCoord[1])
		EndIf
		_GDIPlus_GraphicsDrawRect($hBackbuffer, 250, 250, 50, 50)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $Width, $Height)
	Else
		_GDIPlus_GraphicsClear($hBackbuffer, 0xFF005508)
		_DrawTools()
		_GDIPlus_GraphicsDrawRect($hBackbuffer, 250, 250, 50, 50)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $Width, $Height)
	EndIf
EndFunc   ;==>_ReDraw
Func _DrawTools()
	For $i = 0 To UBound($Felder) - 1
		Switch $Felder[$i][2]
			Case 1
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iPflanzen, $Felder[$i][0], $Felder[$i][1])
			Case 2
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iGras, $Felder[$i][0], $Felder[$i][1])
			Case 3
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseOben, $Felder[$i][0], $Felder[$i][1])
			Case 4
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseRechts, $Felder[$i][0], $Felder[$i][1])
			Case 5
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iBaum, $Felder[$i][0], $Felder[$i][1])
			Case 6
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iStrasseRundlauf, $Felder[$i][0], $Felder[$i][1])
			Case 7
				_GDIPlus_GraphicsDrawImage($hBackbuffer, $iMauer, $Felder[$i][0], $Felder[$i][1])
		EndSwitch
	Next
EndFunc   ;==>_DrawTools